#!/bin/csh
# usage : rc_f2h_[n,r].csh HiPic/ {x0} {y1 y2} Rx Ry
#
set script=`basename $0`
switch($script)
  case rc_f2h_n.csh:
    set views='0,int(v/2)' ; breaksw
  case rc_f2h_r.csh:
    set views='int(v/2),v' ; breaksw
  default:
    echo echo $script : unknown script. 1\>\&2 | /bin/sh ; exit 1
endsw
#
set tmp=/dev/shm/rc_f2h.$$
#
switch($#argv)
  case 3:
    set x0= ; set y12= ; set rxy=($argv[2-3]) ; breaksw
  case 4:
    set x0=$argv[2] ; set y12= ; set rxy=($argv[3-4]) ; breaksw
  case 5:
    set x0= ; set y12=($argv[2-3]); set rxy=($argv[4-5]) ; breaksw
  case 6:
    set x0=$argv[2] ; set y12=($argv[3-4]); set rxy=($argv[5-6]) ; breaksw
  default:
    echo echo usage : $script HiPic/ \{x0\} \{y1 y2\} Rx Ry 1\>\&2 | /bin/sh
    exit 1
endsw
#
set hp=$argv[1]
set v12=(`dit_tbl $hp | \
          awk "{ if (NF!=2) ++s; else if (s==2) ++v } END { print $views }"`)
if ($#v12 != 2) exit 1
#
onintr eos
mkdir $tmp
#
hp2xp $hp ${v12[1]},$v12[2] ${tmp}/%d >/dev/null
if ($status) goto eos
#
set nxy=(`pig ${tmp}/$v12[1]`)
@ nx_1 = $nxy[1] - 1
#
if ($x0 == '') then
  set x0=`echo $nx_1 / 2 | bc -l`
else
  if (`echo "$x0 <= 0 || $x0 >= $nx_1" | bc -l`) then
    echo echo $x0 : bad assumed rotation center. 1\>\&2 | /bin/sh ; goto eos
  endif
endif
#
if ($#y12 != 2) then
  set y12=(0 `expr $nxy[2] - 1`)
else
  trim_float $tmp - 0 $y12[1] $nx_1 $y12[2] $tmp >/dev/null
  if ($status) goto eos
endif
#
set dxy=(`echo $nx_1 $x0 $y12 $rxy | \
          awk '$5>0 && $5<1 && $6>0 && $6<1 { \
                 cx=$2*2-$1; dx=($1+1)*$5; dy=int(($4-$3+1)*$6); \
                 print int(cx-dx-0.5),-dy,int(cx+dx+0.5),dy }'`)
if ($#dxy != 4) then
  echo echo $rxy : bad ratio of displacement. 1\>\&2 | /bin/sh ; goto eos
endif
#
set tbs=(`t2t_float $tmp --n 16 $tmp | sed s@\^@${tmp}/@g`)
rar_gray $tbs[4] -x +y $tbs[4]
#
( echo $nx_1 $dxy ; \
  rmsd_2d.CC $tbs $dxy | sort -n -k 3 ) | \
awk 'NR==1 { X=$1; x1=(X+$2)/2; y1=$3; x2=(X+$4)/2; y2=$5 } \
     NR==2 { printf "%g\t%g\t%g\t%s\t%s\t%s\n",x1,x2,(X+$1)/2,y1,y2,$2 }'
#
eos:
rm -rf $tmp
